package com.xylink.config;

import com.xylink.util.SignUtil;

import java.util.Map;

import  com.xylink.config.SignatureVersion;

/**
 * Created by wenya on 17/9/11.
 */
public class SDKConfig {
    private String serverHost;
    private String accessToken;
    private String refreshToken;
    private String xyClientid;
    private String xyClientSecret;
    private String enterpriseId;
    private String xySignSecret;
    private SignUtil.SignType signType;
    //accessToken过期时间（秒）
    private int accessTokenExpireIn;

    private boolean enableNewSign = false;
    private Map<String,String> extrasHeader;

    private SignatureVersion signatureVersion = SignatureVersion.Signature_1_0;


    public SignatureVersion getSignatureVersion() {
        return signatureVersion;
    }

    public void setSignatureVersion(SignatureVersion signatureVersion) {
        this.signatureVersion = signatureVersion;
    }

    public String getServerHost() {
        return serverHost;
    }

    public void setServerHost(String serverHost) {
        this.serverHost = serverHost;
    }

    public String getAccessToken() {
        return accessToken;
    }

    public void setAccessToken(String accessToken) {
        this.accessToken = accessToken;
    }

    public String getXyClientid() {
        return xyClientid;
    }

    public void setXyClientid(String xyClientid) {
        this.xyClientid = xyClientid;
    }

    public boolean isEnableNewSign() {
        return enableNewSign;
    }

    public void setEnableNewSign(boolean enableNewSign) {
        this.enableNewSign = enableNewSign;
    }

    public String getXyClientSecret() {
        return xyClientSecret;
    }

    public void setXyClientSecret(String xyClientSecret) {
        this.xyClientSecret = xyClientSecret;
    }

    public String getEnterpriseId() {
        return enterpriseId;
    }

    public void setEnterpriseId(String enterpriseId) {
        this.enterpriseId = enterpriseId;
    }

    public String getRefreshToken() {
        return refreshToken;
    }

    public void setRefreshToken(String refreshToken) {
        this.refreshToken = refreshToken;
    }

    public int getAccessTokenExpireIn() {
        return accessTokenExpireIn;
    }

    public void setAccessTokenExpireIn(int accessTokenExpireIn) {
        this.accessTokenExpireIn = accessTokenExpireIn;
    }

    public String getXySignSecret() {
        return xySignSecret;
    }

    public void setXySignSecret(String xySignSecret) {
        this.xySignSecret = xySignSecret;
    }

    public SignUtil.SignType getSignType() {
        return signType;
    }

    public void setSignType(SignUtil.SignType signType) {
        this.signType = signType;
    }

    public Map<String, String> getExtrasHeader() {
        return extrasHeader;
    }

    public void setExtrasHeader(Map<String, String> extrasHeader) {
        this.extrasHeader = extrasHeader;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder("{");
        sb.append("\"serverHost\":\"").append(serverHost).append('\"');
        sb.append(",\"accessToken\":\"").append(accessToken).append('\"');
        sb.append(",\"refreshToken\":\"").append(refreshToken).append('\"');
        sb.append(",\"xyClientid\":\"").append(xyClientid).append('\"');
        sb.append(",\"xyClientSecret\":\"").append(xyClientSecret).append('\"');
        sb.append(",\"enterpriseId\":\"").append(enterpriseId).append('\"');
        sb.append(",\"xySignSecret\":\"").append(xySignSecret).append('\"');
        sb.append(",\"signType\":").append(signType);
        sb.append(",\"accessTokenExpireIn\":").append(accessTokenExpireIn);
        sb.append(",\"enableNewSign\":").append(enableNewSign);
        sb.append(",\"extrasHeader\":").append(extrasHeader);
        sb.append('}');
        return sb.toString();
    }
}
